org.apache.jasper

## Class JspCompilationContext

- java.lang.Object
- - org.apache.jasper.JspCompilationContext

-     public class JspCompilationContext
      extends Object

  A place holder for various things that are used through out the JSP engine. This is a per-request/per-context data structure. Some of the instance variables are set at different points. Most of the path-related stuff is here - mangling names, versions, dirs, loading resources and dealing with uris.
  Author:
    Anil K. Vijendran, Harish Prabandham, Pierre Delisle, Costin Manolache, Kin-man Chung

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `basePackageName`
    `protected String` | `baseURI`
    `protected URL` | `baseUrl`
    `protected String` | `classFileName`
    `protected String` | `className`
    `protected String` | `classPath`
    `protected ServletContext` | `context`
    `protected String` | `derivedPackageName`
    `protected boolean` | `isTagFile`
    `protected String` | `javaPath`
    `protected Compiler` | `jspCompiler`
    `protected URLClassLoader` | `jspLoader`
    `protected String` | `jspUri`
    `protected JspServletWrapper` | `jsw`
    `protected ClassLoader` | `loader`
    `protected Options` | `options`
    `protected String` | `outputDir`
    `protected boolean` | `protoTypeMode`
    `protected JspRuntimeContext` | `rctxt`
    `protected int` | `removed`
    `protected Class<?>` | `servletClass`
    `protected String` | `servletJavaFileName`
    `protected Map<String,JarResource>` | `tagFileJarUrls`
    `protected TagInfo` | `tagInfo`
    `protected JarResource` | `tagJarResource`
    `protected ServletWriter` | `writer`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JspCompilationContext(String jspUri, Options options, ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt)`
    `JspCompilationContext(String tagfile, TagInfo tagInfo, Options options, ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt, JarResource tagJarResource)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static String` | `canonicalURI(String s)`
    `void` | `checkOutputDir()`
    `void` | `clearJspLoader()`
    `void` | `compile()`
    `Compiler` | `createCompiler()` Create a "Compiler" object based on some init param data.
    `protected Compiler` | `createCompiler(String className)`
    `protected void` | `createOutputDir()`
    `String` | `getClassFileName()`
    `ClassLoader` | `getClassLoader()` What class loader to use for loading classes while compiling this JSP?
    `String` | `getClassPath()` The classpath that is passed off to the Java compiler.
    `Compiler` | `getCompiler()`
    `protected String` | `getDerivedPackageName()`
    `String` | `getFQCN()`
    `String` | `getJavaPath()` Path of the Java file relative to the work directory.
    `String` | `getJspFile()` Path of the JSP URI.
    `long` | `getJspLastModified()` Deprecated. Will be removed in Tomcat 8.0.x. Use `getLastModified(String)` instead.
    `ClassLoader` | `getJspLoader()`
    `Long` | `getLastModified(String resource)`
    `Options` | `getOptions()` Get hold of the Options object for this context.
    `String` | `getOutputDir()` The output directory to generate code into.
    `String` | `getRealPath(String path)` Gets the actual path of a URI relative to the context of the compilation.
    `URL` | `getResource(String res)`
    `InputStream` | `getResourceAsStream(String res)` Gets a resource as a stream, relative to the meanings of this context's implementation.
    `Set<String>` | `getResourcePaths(String path)`
    `JspRuntimeContext` | `getRuntimeContext()`
    `String` | `getServletClassName()` Just the class name (does not include package name) of the generated class.
    `ServletContext` | `getServletContext()`
    `String` | `getServletJavaFileName()` Full path name of the Java file into which the servlet is being generated.
    `String` | `getServletPackageName()` Package name for the generated class is make up of the base package name, which is user settable, and the derived package name.
    `JarResource` | `getTagFileJarResource()` Returns the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.
    `JarResource` | `getTagFileJarResource(String tagFile)` Returns the tag-file-name-to-JAR-file map of this compilation unit, which maps tag file names to the JAR files in which the tag files are packaged.
    `TagInfo` | `getTagInfo()`
    `TldLocation` | `getTldLocation(String uri)` Gets the 'location' of the TLD associated with the given taglib 'uri'.
    `ServletWriter` | `getWriter()` Where is the servlet being generated?
    `void` | `incrementRemoved()`
    `protected static boolean` | `isPathSeparator(char c)`
    `boolean` | `isPrototypeMode()` True if we are compiling a tag file in prototype mode.
    `boolean` | `isRemoved()`
    `boolean` | `isTagFile()`
    `boolean` | `keepGenerated()` Are we keeping generated code around?
    `Class<?>` | `load()`
    `protected boolean` | `makeOutputDir()`
    `String` | `resolveRelativeUri(String uri)` Get the full value of a URI relative to this compilations context uses current file as the base.
    `void` | `setClassLoader(ClassLoader loader)`
    `void` | `setClassPath(String classPath)` The classpath that is passed off to the Java compiler.
    `void` | `setPrototypeMode(boolean pm)`
    `void` | `setServletClassName(String className)`
    `void` | `setServletPackageName(String servletPackageName)` The package name into which the servlet class is generated.
    `void` | `setTagFileJarResource(String tagFile, JarResource jarResource)`
    `void` | `setTagInfo(TagInfo tagi)`
    `void` | `setWriter(ServletWriter writer)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### tagFileJarUrls

          protected Map<String,JarResource> tagFileJarUrls

    - #### className

          protected String className

    - #### jspUri

          protected String jspUri

    - #### basePackageName

          protected String basePackageName

    - #### derivedPackageName

          protected String derivedPackageName

    - #### servletJavaFileName

          protected String servletJavaFileName

    - #### javaPath

          protected String javaPath

    - #### classFileName

          protected String classFileName

    - #### writer

          protected ServletWriter writer

    - #### options

          protected Options options

    - #### jsw

          protected JspServletWrapper jsw

    - #### jspCompiler

          protected Compiler jspCompiler

    - #### classPath

          protected String classPath

    - #### baseURI

          protected String baseURI

    - #### outputDir

          protected String outputDir

    - #### context

          protected ServletContext context

    - #### loader

          protected ClassLoader loader

    - #### rctxt

          protected JspRuntimeContext rctxt

    - #### removed

          protected volatile int removed

    - #### jspLoader

          protected URLClassLoader jspLoader

    - #### baseUrl

          protected URL baseUrl

    - #### servletClass

          protected Class<?> servletClass

    - #### isTagFile

          protected boolean isTagFile

    - #### protoTypeMode

          protected boolean protoTypeMode

    - #### tagInfo

          protected TagInfo tagInfo

    - #### tagJarResource

          protected JarResource tagJarResource

  - ### Constructor Detail

    - #### JspCompilationContext

          public JspCompilationContext(String jspUri,
                               Options options,
                               ServletContext context,
                               JspServletWrapper jsw,
                               JspRuntimeContext rctxt)

    - #### JspCompilationContext

          public JspCompilationContext(String tagfile,
                               TagInfo tagInfo,
                               Options options,
                               ServletContext context,
                               JspServletWrapper jsw,
                               JspRuntimeContext rctxt,
                               JarResource tagJarResource)

  - ### Method Detail

    - #### getClassPath

          public String getClassPath()

      The classpath that is passed off to the Java compiler.

    - #### setClassPath

          public void setClassPath(String classPath)

      The classpath that is passed off to the Java compiler.

    - #### getClassLoader

          public ClassLoader getClassLoader()

      What class loader to use for loading classes while compiling this JSP?

    - #### setClassLoader

          public void setClassLoader(ClassLoader loader)

    - #### getJspLoader

          public ClassLoader getJspLoader()

    - #### clearJspLoader

          public void clearJspLoader()

    - #### getOutputDir

          public String getOutputDir()

      The output directory to generate code into. The output directory is make up of the scratch directory, which is provide in Options, plus the directory derived from the package name.

    - #### createCompiler

          public Compiler createCompiler()

      Create a "Compiler" object based on some init param data. This is not done yet. Right now we're just hardcoding the actual compilers that are created.

    - #### createCompiler

          protected Compiler createCompiler(String className)

    - #### getCompiler

          public Compiler getCompiler()

    - #### resolveRelativeUri

          public String resolveRelativeUri(String uri)

      Get the full value of a URI relative to this compilations context uses current file as the base.

    - #### getResourceAsStream

          public InputStream getResourceAsStream(String res)

      Gets a resource as a stream, relative to the meanings of this context's implementation.
      Returns:
        a null if the resource cannot be found or represented as an InputStream.

    - #### getResource

          public URL getResource(String res)
                          throws MalformedURLException

      Throws:
        `MalformedURLException`

    - #### getResourcePaths

          public Set<String> getResourcePaths(String path)

    - #### getRealPath

          public String getRealPath(String path)

      Gets the actual path of a URI relative to the context of the compilation.

    - #### getTagFileJarResource

          public JarResource getTagFileJarResource(String tagFile)

      Returns the tag-file-name-to-JAR-file map of this compilation unit, which maps tag file names to the JAR files in which the tag files are packaged. The map is populated when parsing the tag-file elements of the TLDs of any imported taglibs.

    - #### setTagFileJarResource

          public void setTagFileJarResource(String tagFile,
                                   JarResource jarResource)

    - #### getTagFileJarResource

          public JarResource getTagFileJarResource()

      Returns the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.

    - #### getServletClassName

          public String getServletClassName()

      Just the class name (does not include package name) of the generated class.

    - #### setServletClassName

          public void setServletClassName(String className)

    - #### getJspFile

          public String getJspFile()

      Path of the JSP URI. Note that this is not a file name. This is the context rooted URI of the JSP file.

    - #### getJspLastModified

          @Deprecated
          public long getJspLastModified()

      Deprecated. Will be removed in Tomcat 8.0.x. Use `getLastModified(String)` instead.

    - #### getLastModified

          public Long getLastModified(String resource)

    - #### isTagFile

          public boolean isTagFile()

    - #### getTagInfo

          public TagInfo getTagInfo()

    - #### setTagInfo

          public void setTagInfo(TagInfo tagi)

    - #### isPrototypeMode

          public boolean isPrototypeMode()

      True if we are compiling a tag file in prototype mode. ie we only generate codes with class for the tag handler with empty method bodies.

    - #### setPrototypeMode

          public void setPrototypeMode(boolean pm)

    - #### getServletPackageName

          public String getServletPackageName()

      Package name for the generated class is make up of the base package name, which is user settable, and the derived package name. The derived package name directly mirrors the file hierarchy of the JSP page.

    - #### getDerivedPackageName

          protected String getDerivedPackageName()

    - #### setServletPackageName

          public void setServletPackageName(String servletPackageName)

      The package name into which the servlet class is generated.

    - #### getServletJavaFileName

          public String getServletJavaFileName()

      Full path name of the Java file into which the servlet is being generated.

    - #### getOptions

          public Options getOptions()

      Get hold of the Options object for this context.

    - #### getServletContext

          public ServletContext getServletContext()

    - #### getRuntimeContext

          public JspRuntimeContext getRuntimeContext()

    - #### getJavaPath

          public String getJavaPath()

      Path of the Java file relative to the work directory.

    - #### getClassFileName

          public String getClassFileName()

    - #### getWriter

          public ServletWriter getWriter()

      Where is the servlet being generated?

    - #### setWriter

          public void setWriter(ServletWriter writer)

    - #### getTldLocation

          public TldLocation getTldLocation(String uri)
                                     throws JasperException

      Gets the 'location' of the TLD associated with the given taglib 'uri'.
      Returns:
        An array of two Strings: The first element denotes the real path to the TLD. If the path to the TLD points to a jar file, then the second element denotes the name of the TLD entry in the jar file. Returns null if the given uri is not associated with any tag library 'exposed' in the web application.
      Throws:
        `JasperException`

    - #### keepGenerated

          public boolean keepGenerated()

      Are we keeping generated code around?

    - #### incrementRemoved

          public void incrementRemoved()

    - #### isRemoved

          public boolean isRemoved()

    - #### compile

          public void compile()
                       throws JasperException,
                              FileNotFoundException

      Throws:
        `JasperException`
        `FileNotFoundException`

    - #### load

          public Class<?> load()
                        throws JasperException

      Throws:
        `JasperException`

    - #### getFQCN

          public String getFQCN()

    - #### checkOutputDir

          public void checkOutputDir()

    - #### makeOutputDir

          protected boolean makeOutputDir()

    - #### createOutputDir

          protected void createOutputDir()

    - #### isPathSeparator

          protected static final boolean isPathSeparator(char c)

    - #### canonicalURI

          protected static final String canonicalURI(String s)

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.